/**************************************************************************
**   yapoo 2010
**************************************************************************/
#ifndef BACKENDTHREAD_H
#define BACKENDTHREAD_H

#include <QThread>
#include <QtCore>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>

#include <iostream>
//#include <fstream>
#include <string>
using namespace std;
//#include "mainwindow.h"
//#include "ui_mainwindow.h"
#include "TsPacketReader.h"
#include "psisection.h"

class MainWindow;
/*
class ThreadBase : public QThread
{
	Q_OBJECT
	public:
	ThreadBase(QObject *parent = 0)
	 :QThread( parent )
	{
	}

signals:
	void dataAvailable();
};
*/

class InputBuffer : public QThread
{
	Q_OBJECT

	char *buff;
	char /* *pRead,*/ *pWrite, *pLimit;

//	QString filename;
//	QIODevice *in;
	string filename_in;
	int infd;

//	int threshold;
	static const int buffSize = 1880000 * 10; // 	buffSize -= buffSize % 188;

//	QTimer *timer;
//	QMutex mutex1;
	int read_in();


public:
	void run();

//	InputBuffer( QIODevice *in );
	InputBuffer( const char* );
	~InputBuffer();

//	int read( char *p, int length );
	class Reader
	{
		InputBuffer *buff;
		char *pRead, *pLimit;
	 public:
		Reader( InputBuffer* p );
		int read( char **pp, int length );

	};
	volatile int exitFlag;

};


class PlayerThread: public QThread
{
	Q_OBJECT

	InputBuffer *inputBuffer;
	InputBuffer::Reader *reader;
	QProcess* playerProcess;

//	QIODevice *outputDevice;
	int outfd;
	fd_set wfds;
	string outputFile;

//	QTimer *timer;
//	string pts_name;

	int waitForTsChanged( time_t wait_seconds );
	int doOutput();

public:
	volatile int exitFlag;
	void run();
	int ts_id;

//	PlayerThread( InputBuffer *inputBuffer, QIODevice *outputDevice );
	PlayerThread( InputBuffer *inputBuffer, QProcess* process, const char* outputFile );
	~PlayerThread();

public slots:
};

class Eit_pfOperator;
class SiThread: public QThread
{
	Q_OBJECT

	InputBuffer *inputBuffer;
	InputBuffer::Reader *reader;
	int ts_id;

	Eit_pfOperator *eitOp12,*eitOp27;
	QIODevice *outputDevice;

public:
	volatile int exitFlag;
	void run();

	SiThread( InputBuffer *inputBuffer, MainWindow* );
	~SiThread();
	void doRead();
	int waitForTsChanged( time_t wait_seconds );

public slots:

};

#endif // BACKENDTHREAD_H
