/**************************************************************************
**   yapoo 2010
**************************************************************************/
#include <QtGui/QApplication>
#include "mainwindow.h"
#include <iostream>
#include <signal.h>
#include <string.h>
using namespace std;

int main(int argc, char *argv[])
{
	int ret;
	const char *config = 0;
	__sighandler_t old;
	old = signal( SIGPIPE, SIG_IGN );

	if ( argc >=3 && ::strcmp( argv[1], "-c") == 0 )
	{
		config = argv[2];
	}
	try{
	 QApplication a(argc, argv);
		MainWindow w;
		ret = w.setupConfig(config);
		if ( ret ) return -1;
		w.show();
		return a.exec();
	} catch (exception &e) {
		cerr << e.what() << endl;
	}
}
